#include "mbed.h"

#define bauds 115200

RawSerial  pc(USBTX, USBRX);
RawSerial  dev(D8,D2);  //TX,RX   PA_11,PA_12  ou PA_9,PA_10

DigitalOut led1(LED1);
DigitalOut led4(LED4);

void dev_recv()
{
    led1 = !led1;
    while(dev.readable()) {
        pc.putc(dev.getc());
    }
}

void pc_recv()
{
    led4 = !led4;
    while(pc.readable()) {
        dev.putc(pc.getc());
    }
}

int main()
{
    pc.baud(bauds);
    dev.baud(bauds);
    pc.printf("PASSTHROUGH ACTIF VITESSE -> %d BAUDS\n",bauds);


    pc.attach(&pc_recv, Serial::RxIrq);
    dev.attach(&dev_recv, Serial::RxIrq);


    while(1) {
        sleep();
    }
}
